
Enduro/X Core - Bug #353

Feature # 328 (Closed): Enduro/X Version 6.0 master task

tpbridge queue runner

11/16/2018 02:55 PM - Madars

Status: Closed Start date: 11/16/2018

Priority: Normal (Code 4) Due date:  

Assignee:  % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

Description

In case if target IPC queue is full tpbridge shall attempt to deliver the message to target by some interval. Also we might want some

try counter and discard deliverable messages.

1. The retry could be done by doing next any queue delivery or

2. Or by "poll_timer" timer.

Thus also we need some configuration flag for controlling number of attempts before discarding the message.

test38

/* shouldn't we enqueue for later delivery????  */

 :NDRX:3:b86e6a53:32144:7fc7e36e1300:003:20181116:143532598:x_sem_unlock:td_sem.c:0225:@TPBRDCST001/99483649/25

 semaphore un-locked

 :NDRX:3:b86e6a53:32144:7fc7e36e1300:003:20181116:143532646:drx_sem_lock:td_sem.c:0182:@TPBRDCST001/99483649/25:

 semaphore locked...

 :NDRX:3:b86e6a53:32144:7fc7e36e1300:003:20181116:143532646:x_sem_unlock:td_sem.c:0225:@TPBRDCST001/99483649/25

 semaphore un-locked

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143532661:ric_q_send_2:iutils.c:0377:mq_flags=2048 mq_maxmsg=50

 mq_msgsize=1049600 mq_curmsgs=50

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143532661:ric_q_send_2:iutils.c:0380:Failed to send data to queue

 [/dom1,clt,reply,atmiclt38,32196,1] with error: 11:Resource temporarily unavailable

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143532662:t_reply_to_q:/queue.c:0322:Failed to send message to

 /dom1,clt,reply,atmiclt38,32196,1!

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143532746:ric_q_send_2:iutils.c:0377:mq_flags=2048 mq_maxmsg=50

 mq_msgsize=1049600 mq_curmsgs=50

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143532746:ric_q_send_2:iutils.c:0380:Failed to send data to queue

 [/dom1,clt,reply,atmiclt38,32196,1] with error: 11:Resource temporarily unavailable

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143532749:t_reply_to_q:/queue.c:0322:Failed to send message to

 /dom1,clt,reply,atmiclt38,32196,1!

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143543006:oto_proto2ex:/proto.c:1813:Experimental verification:

 WARNING! INVALID LEN! tag: 0x105f (magic) min_len=6 max_len=6 but got: 5

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143615003:ild_ex2proto:/proto.c:1563:Experimental verification:

 WARNING! INVALID LEN! tag: 0x105f (magic) min_len=6 max_len=6 but got: 5

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143642005:oto_proto2ex:/proto.c:1813:Experimental verification:

 WARNING! INVALID LEN! tag: 0x105f (magic) min_len=6 max_len=6 but got: 5

 :NDRX:2:b86e6a53:32144:7fc7e36e1300:003:20181116:143714002:ild_ex2proto:/proto.c:1563:Experimental verification:

 WARNING! INVALID LEN! tag: 0x105f (magic) min_len=6 max_len=6 but got: 5

after kill -11 :

ASAN:DEADLYSIGNAL

=================================================================

==32196==ERROR: AddressSanitizer: SEGV on unknown address 0x03e900006b5d (pc 0x7efe0e7a1f85 bp 0x000000000000 sp

 0x7ffd5fb621e0 T0)

==32196==The signal is caused by a READ memory access.

    #0 0x7efe0e7a1f84 in pthread_cond_timedwait@@GLIBC_2.3.2 (/lib/x86_64-linux-gnu/libpthread.so.0+0xdf84)

    #1 0x7efe0f1f5f1f in emq_timedreceive /home/user1/endurox/libnstd/sys_emqueue.c:660

    #2 0x7efe0f796409 in ndrx_generic_q_receive /home/user1/endurox/libatmi/atmiutils.c:434

    #3 0x7efe0f77f3fd in ndrx_tpgetrply /home/user1/endurox/libatmi/tpcall.c:715
    #4 0x7efe0f7730a7 in tpgetrply /home/user1/endurox/libatmi/atmi.c:283

    #5 0x557997196f92 in handle_replies /home/user1/endurox/atmitest/test038_tpnotify/atmiclt38.c:94

    #6 0x557997197d20 in main /home/user1/endurox/atmitest/test038_tpnotify/atmiclt38.c:182

    #7 0x7efe0ede0b96 in __libc_start_main (/lib/x86_64-linux-gnu/libc.so.6+0x21b96)

    #8 0x557997196c69 in _start (/home/user1/endurox/atmitest/test038_tpnotify/atmiclt38+0x1c69)

AddressSanitizer can not provide additional info.

SUMMARY: AddressSanitizer: SEGV (/lib/x86_64-linux-gnu/libpthread.so.0+0xdf84) in pthread_cond_timedwait@@GLIBC_2.3.2

==32196==ABORTING

History

#1 - 11/16/2018 02:56 PM - Madars

- Description updated

#2 - 11/18/2018 04:54 PM - Madars

- Status changed from New to Resolved

#3 - 11/18/2018 04:54 PM - Madars

- Status changed from Resolved to Closed

#4 - 12/03/2018 07:11 AM - Madars

- % Done changed from 0 to 100
